﻿Imports System.Data.SqlClient
Public Class FContactos
    Inherits Conexion
    Dim Cmd As New SqlCommand
    Public Function Mostrar() As DataTable
        Try
            Conectado()
            Cmd = New SqlCommand("mostrar_contacto_todos")
            Cmd.CommandType = CommandType.StoredProcedure
            Cmd.Connection = Cnn
            If Cmd.ExecuteNonQuery Then
                Dim Dt As New DataTable
                Dim Da As New SqlDataAdapter(Cmd)
                Da.Fill(Dt)
                Return Dt
            Else
                Return Nothing
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return Nothing
        Finally
            Desconectado()
        End Try
    End Function
    Public Function Insertar(ByVal Dts As VContactos) As Boolean
        Try
            Conectado()
            Cmd = New SqlCommand("insertar_contacto")
            Cmd.CommandType = CommandType.StoredProcedure
            Cmd.Connection = Cnn
            Cmd.Parameters.AddWithValue("@nombres", Dts.gNombres)
            Cmd.Parameters.AddWithValue("@apellidos", Dts.gApellidos)
            Cmd.Parameters.AddWithValue("@empresa", Dts.gEmpresa)
            Cmd.Parameters.AddWithValue("@puesto", Dts.gPuesto)
            Cmd.Parameters.AddWithValue("@telemp", Dts.gTelEmp)
            Cmd.Parameters.AddWithValue("@extemp", Dts.gExtEmp)
            Cmd.Parameters.AddWithValue("@coremp", Dts.gCorEmp)
            Cmd.Parameters.AddWithValue("@cel", Dts.gCel)
            Cmd.Parameters.AddWithValue("@notas", Dts.gNotas)
            Cmd.Parameters.AddWithValue("@coreper", Dts.gCorePer)
            If Cmd.ExecuteNonQuery Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return False
        Finally
            Desconectado()
        End Try
    End Function
    Public Function Editar(ByVal Dts As VContactos) As Boolean
        Try
            Conectado()
            Cmd = New SqlCommand("editar_contacto")
            Cmd.CommandType = CommandType.StoredProcedure
            Cmd.Connection = Cnn
            Cmd.Parameters.AddWithValue("@idcontacto", Dts.gIdContacto)
            Cmd.Parameters.AddWithValue("@nombres", Dts.gNombres)
            Cmd.Parameters.AddWithValue("@apellidos", Dts.gApellidos)
            Cmd.Parameters.AddWithValue("@empresa", Dts.gEmpresa)
            Cmd.Parameters.AddWithValue("@puesto", Dts.gPuesto)
            Cmd.Parameters.AddWithValue("@telemp", Dts.gTelEmp)
            Cmd.Parameters.AddWithValue("@extemp", Dts.gExtEmp)
            Cmd.Parameters.AddWithValue("@coremp", Dts.gCorEmp)
            Cmd.Parameters.AddWithValue("@cel", Dts.gCel)
            Cmd.Parameters.AddWithValue("@notas", Dts.gNotas)
            Cmd.Parameters.AddWithValue("@coreper", Dts.gCorePer)
            If Cmd.ExecuteNonQuery Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return False
        Finally
            Desconectado()
        End Try
    End Function
    Public Function Eliminar(ByVal Dts As VContactos) As Boolean
        Try
            Conectado()
            Cmd = New SqlCommand("eliminar_contacto")
            Cmd.CommandType = CommandType.StoredProcedure
            Cmd.Connection = Cnn
            Cmd.Parameters.Add("@idcontacto", SqlDbType.NVarChar, 50).Value = Dts.gIdContacto
            If Cmd.ExecuteNonQuery Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return False
        Finally
            Desconectado()
        End Try
    End Function
End Class
