﻿Public Class FrmUsuarios
    Private Dt As New DataTable
    Private Titulo As String = "GB Agenda v1.0.0"
    Private Sub FrmUsuarios_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Mostrar()
        Limpiar()
        BtnEliminar.Enabled = False
    End Sub
    Private Sub Mostrar()
        Try
            Dim Func As New FUsuarios
            Dt = Func.Mostrar
            DataUsuarios.Columns.Item("ELIMINAR").Visible = False
            If Dt.Rows.Count <> 0 Then
                DataUsuarios.DataSource = Dt
                TxtBuscar.Enabled = True
                DataUsuarios.ColumnHeadersVisible = True
                DataUsuarios.Columns(2).HeaderText = "Usuario"
                DataUsuarios.Columns(4).HeaderText = "Nombre(s)"
                DataUsuarios.Columns(5).HeaderText = "Apellido(s)"
                DataUsuarios.Columns(6).HeaderText = "Es Administrador?"
                Inexistente.Visible = False
            Else
                DataUsuarios.DataSource = Nothing
                TxtBuscar.Enabled = False
                DataUsuarios.ColumnHeadersVisible = False
                Inexistente.Visible = True
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
        BtnNuevo.Enabled = True
        BtnEditar.Enabled = False
        Buscar()
    End Sub
    Private Sub Buscar()
        Try
            Dim Ds As New DataSet
            Ds.Tables.Add(Dt.Copy)
            Dim Dv As New DataView(Ds.Tables(0))
            Dv.RowFilter = CmbBuscar.Text & " LIKE '%" & TxtBuscar.Text & "%'"
            If Dv.Count <> 0 Then
                Inexistente.Visible = False
                DataUsuarios.DataSource = Dv
                OcultarColumnas()
            Else
                Inexistente.Visible = True
                DataUsuarios.DataSource = Nothing
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub
    Private Sub Limpiar()
        BtnGuardar.Enabled = True
        BtnEditar.Enabled = False
        TxtUsuario.Enabled = True
        TxtIdUsuario.Text = ""
        TxtUsuario.Text = ""
        TxtClave.Text = ""
        TxtNombres.Text = ""
        TxtApellidos.Text = ""
        ChAdministrar.Checked = False
    End Sub
    Private Sub OcultarColumnas()
        DataUsuarios.Columns(1).Visible = False
        DataUsuarios.Columns(3).Visible = False
    End Sub

    Private Sub TxtUsuario_Validating(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles TxtUsuario.Validating
        If DirectCast(sender, TextBox).Text.Length > 0 Then
            ErrorUsuario.SetError(sender, "")
        Else
            ErrorUsuario.SetError(sender, "CAMPO OBLIGATORIO")
        End If
    End Sub

    Private Sub TxtClave_Validating(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles TxtClave.Validating
        If DirectCast(sender, TextBox).Text.Length > 0 Then
            ErrorUsuario.SetError(sender, "")
        Else
            ErrorUsuario.SetError(sender, "CAMPO OBLIGATORIO")
        End If
    End Sub

    Private Sub TxtNombres_Validating(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles TxtNombres.Validating
        If DirectCast(sender, TextBox).Text.Length > 0 Then
            ErrorUsuario.SetError(sender, "")
        Else
            ErrorUsuario.SetError(sender, "CAMPO OBLIGATORIO")
        End If
    End Sub

    Private Sub BtnNuevo_Click(sender As Object, e As EventArgs) Handles BtnNuevo.Click
        Limpiar()
        Mostrar()
        ChEliminar.Checked = False
    End Sub

    Private Sub BtnGuardar_Click(sender As Object, e As EventArgs) Handles BtnGuardar.Click
        If TxtUsuario.Text = "" And TxtClave.Text = "" And TxtNombres.Text = "" Then
            ErrorUsuario.SetError(TxtUsuario, "CAMPO OBLIGATORIO")
            ErrorUsuario.SetError(TxtClave, "CAMPO OBLIGATORIO")
            ErrorUsuario.SetError(TxtNombres, "CAMPO OBLIGATORIO")
        End If
        If TxtUsuario.Text = "" Then
            ErrorUsuario.SetError(TxtUsuario, "CAMPO OBLIGATORIO")
        ElseIf TxtClave.Text = "" Then
            ErrorUsuario.SetError(TxtClave, "CAMPO OBLIGATORIO")
        ElseIf TxtNombres.Text = "" Then
            ErrorUsuario.SetError(TxtNombres, "CAMPO OBLIGATORIO")
        Else
            Try
                Dim Dts As New VUsuarios
                Dim Func As New FUsuarios
                Dts.gUsuario = TxtUsuario.Text
                Dts.gClave = TxtClave.Text
                Dts.gNombres = TxtNombres.Text
                Dts.gApellidos = TxtApellidos.Text
                If ChAdministrar.Checked = True Then
                    Dts.gAdministrar = "SI"
                Else
                    Dts.gAdministrar = "NO"
                End If
                If Func.Insertar(Dts) Then
                    MsgBox("Usuario Registrado Exitosamente", MsgBoxStyle.OkOnly + MsgBoxStyle.Information, Titulo)
                    Mostrar()
                    Limpiar()
                Else
                    MsgBox("El Usuario No Se Pudo Registrar", MsgBoxStyle.OkOnly + MsgBoxStyle.Exclamation, Titulo)
                    Mostrar()
                End If
            Catch ex As Exception
                MsgBox(ex.ToString)
            End Try
        End If
    End Sub

    Private Sub DataUsuarios_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles DataUsuarios.CellContentClick
        If DataUsuarios.Rows(e.RowIndex).Cells("idusuario").Value = 1 Then
            MsgBox("No Se Puede Eliminar El Usuario ADMIN!!!" & vbNewLine & "Solo Se Puede Modificar", MsgBoxStyle.Exclamation)
        Else
            If e.ColumnIndex = Me.DataUsuarios.Columns.Item("ELIMINAR").Index Then
                Dim Chkcell As DataGridViewCheckBoxCell = Me.DataUsuarios.Rows(e.RowIndex).Cells("ELIMINAR")
                Chkcell.Value = Not Chkcell.Value
            End If
        End If
    End Sub

    Private Sub DataUsuarios_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DataUsuarios.CellClick
        TxtUsuario.Enabled = False
        TxtIdUsuario.Text = DataUsuarios.SelectedCells.Item(1).Value
        TxtUsuario.Text = DataUsuarios.SelectedCells.Item(2).Value
        TxtClave.Text = DataUsuarios.SelectedCells.Item(3).Value
        TxtNombres.Text = DataUsuarios.SelectedCells.Item(4).Value
        TxtApellidos.Text = DataUsuarios.SelectedCells.Item(5).Value
        If DataUsuarios.SelectedCells.Item(6).Value = "SI" Then
            ChAdministrar.Checked = True
        Else
            ChAdministrar.Checked = False
        End If
        BtnEditar.Enabled = True
        BtnGuardar.Enabled = False
    End Sub

    Private Sub BtnEditar_Click(sender As Object, e As EventArgs) Handles BtnEditar.Click
        If TxtUsuario.Text = "" And TxtClave.Text = "" And TxtNombres.Text = "" Then
            ErrorUsuario.SetError(TxtUsuario, "CAMPO OBLIGATORIO")
            ErrorUsuario.SetError(TxtClave, "CAMPO OBLIGATORIO")
            ErrorUsuario.SetError(TxtNombres, "CAMPO OBLIGATORIO")
        End If
        If TxtUsuario.Text = "" Then
            ErrorUsuario.SetError(TxtUsuario, "CAMPO OBLIGATORIO")
        ElseIf TxtClave.Text = "" Then
            ErrorUsuario.SetError(TxtClave, "CAMPO OBLIGATORIO")
        ElseIf TxtNombres.Text = "" Then
            ErrorUsuario.SetError(TxtNombres, "CAMPO OBLIGATORIO")
        Else
            Dim pregunta As MsgBoxResult
            pregunta = MsgBox("Realmente Desea Editar Los Datos Del Usuario: " & TxtUsuario.Text, MsgBoxStyle.YesNo + MsgBoxStyle.Question, Titulo)
            If pregunta = MsgBoxResult.No Then
                Exit Sub
            End If
            Try
                Dim Dts As New VUsuarios
                Dim Func As New FUsuarios
                Dts.gIdUsuario = TxtIdUsuario.Text
                Dts.gUsuario = TxtUsuario.Text
                Dts.gClave = TxtClave.Text
                Dts.gNombres = TxtNombres.Text
                Dts.gApellidos = TxtApellidos.Text
                If ChAdministrar.Checked = True Then
                    Dts.gAdministrar = "SI"
                Else
                    Dts.gAdministrar = "NO"
                End If
                If Func.Editar(Dts) Then
                    MsgBox("Usuario Modificado Exitosamente", MsgBoxStyle.OkOnly + MsgBoxStyle.Information, Titulo)
                    Mostrar()
                    Limpiar()
                Else
                    MsgBox("El Usuario No Se Pudo Modificar", MsgBoxStyle.OkOnly + MsgBoxStyle.Exclamation, Titulo)
                    Mostrar()
                End If
            Catch ex As Exception
                MsgBox(ex.ToString)
            End Try
        End If
    End Sub

    Private Sub ChMostrarClave_CheckedChanged(sender As Object, e As EventArgs) Handles ChMostrarClave.CheckedChanged
        If ChMostrarClave.Checked = True Then
            TxtClave.PasswordChar = ""
            ChMostrarClave.Text = "Ocultar Clave"
        Else
            TxtClave.PasswordChar = "*"
            ChMostrarClave.Text = "Mostrar Clave"
        End If
    End Sub

    Private Sub ChEliminar_CheckedChanged(sender As Object, e As EventArgs) Handles ChEliminar.CheckedChanged
        If ChEliminar.CheckState = CheckState.Checked Then
            DataUsuarios.Columns.Item("ELIMINAR").Visible = True
            BtnEliminar.Enabled = True
        Else
            DataUsuarios.Columns.Item("ELIMINAR").Visible = False
            BtnEliminar.Enabled = False
        End If
    End Sub

    Private Sub TxtBuscar_TextChanged(sender As Object, e As EventArgs) Handles TxtBuscar.TextChanged
        Mostrar()
    End Sub

    Private Sub BtnEliminar_Click(sender As Object, e As EventArgs) Handles BtnEliminar.Click
        Dim Pregunta As MsgBoxResult
        Pregunta = MsgBox("¿Realmente Desea Eliminar Los Usuarios Seleccionados?", MsgBoxStyle.YesNo + MsgBoxStyle.Question)
        If Pregunta = MsgBoxResult.Yes Then
            Try
                For Each Row As DataGridViewRow In DataUsuarios.Rows
                    Dim Marcado As Boolean = Convert.ToBoolean(Row.Cells("ELIMINAR").Value)
                    If Marcado Then
                        Dim OneKey As Integer = Convert.ToInt32(Row.Cells("idusuario").Value)
                        Dim Vdb As New VUsuarios
                        Dim Func As New FUsuarios
                        Vdb.gIdUsuario = OneKey
                        If Func.Eliminar(Vdb) Then
                        Else
                            MsgBox("No Se Pudo Eliminar El Usuario", MsgBoxStyle.YesNo + MsgBoxStyle.Exclamation)
                        End If
                    End If
                Next
            Catch ex As Exception
                MsgBox(ex.ToString)
            End Try
        Else

        End If
        ChEliminar.Checked = False
        Mostrar()
        Limpiar()
    End Sub
End Class