CREATE DATABASE AGENDA
GO
USE AGENDA
GO
CREATE TABLE USUARIOS
(
idusuario int primary key not null identity(1,1),
usuario varchar(50),
clave varchar(50),
nombres varchar(50),
apellidos varchar(50),
administrar varchar(2)
)
go
insert into USUARIOS(usuario,clave,nombres,apellidos,administrar)
values('ADMIN','ADMIN','ADMIN','ADMIN','SI')
go
create proc mostrar_usuario
as
select * from USUARIOS
go
create proc validar_usuario
@usuario varchar(50),
@clave varchar(50)
as
select * from USUARIOS
where usuario=@usuario and clave=@clave
go
create proc validar_administrador
@usuario varchar(50),
@clave varchar(50)
as
select * from USUARIOS
where usuario=@usuario and clave=@clave and administrar='SI'
go
create proc insertar_usuario
@usuario varchar(50),
@clave varchar(50),
@nombres varchar(50),
@apellidos varchar(50),
@administrar varchar(2)
as
insert into USUARIOS (usuario,clave,nombres,apellidos,administrar)
values (@usuario,@clave,@nombres,@apellidos,@administrar)
go
create proc editar_usuario
@idusuario int,
@usuario varchar(50),
@clave varchar(50),
@nombres varchar(50),
@apellidos varchar(50),
@administrar varchar(2)
as
update USUARIOS set usuario=@usuario,clave=@clave,nombres=@nombres,apellidos=@apellidos,administrar=@administrar
where idusuario=@idusuario
go
create proc eliminar_usuario
@idusuario int
as
delete from USUARIOS where idusuario=@idusuario
go
create table CONTACTOS
(
idcontacto int primary key not null identity(1,1),
nombres varchar(50),
apellidos varchar(50),
empresa varchar(255),
puesto varchar(100),
telemp varchar(10),
extemp varchar(5),
coremp varchar(100),
cel varchar(12),
notas text,
coreper varchar(100)
)
go
create proc mostrar_contacto_todos
as
select * from CONTACTOS
go
create proc mostrar_contacto
@idcontacto int
as
select * from CONTACTOS where idcontacto=@idcontacto
go
create proc insertar_contacto
@nombres varchar(50),
@apellidos varchar(50),
@empresa varchar(255),
@puesto varchar(100),
@telemp varchar(10),
@extemp varchar(5),
@coremp varchar(100),
@cel varchar(12),
@notas text,
@coreper varchar(100)
as
insert into CONTACTOS (nombres,apellidos,empresa,puesto,telemp,extemp,coremp,cel,notas,coreper)
values (@nombres,@apellidos,@empresa,@puesto,@telemp,@extemp,@coremp,@cel,@notas,@coreper)
go
create proc editar_contacto
@idcontacto int,
@nombres varchar(50),
@apellidos varchar(50),
@empresa varchar(255),
@puesto varchar(100),
@telemp varchar(10),
@extemp varchar(5),
@coremp varchar(100),
@cel varchar(12),
@notas text,
@coreper varchar(100)
as
update CONTACTOS set nombres=@nombres,apellidos=@apellidos,empresa=@empresa,puesto=@puesto,
telemp=@telemp,extemp=@extemp,coremp=@coremp,cel=@cel,notas=@notas,coreper=@coreper
where idcontacto=@idcontacto
go
create proc eliminar_contacto
@idcontacto int
as
delete from CONTACTOS where idcontacto=@idcontacto
go
create table EVENTOS
(
idevento int primary key not null identity(1,1),
fecha smalldatetime,
asunto varchar(255),
idcontacto int
constraint FK_EVENTOS_idcontacto foreign key(idcontacto) references CONTACTOS(idcontacto)
)
go
create proc mostrar_evento_del_dia
as
select dbo.EVENTOS.idevento, dbo.EVENTOS.fecha, dbo.EVENTOS.asunto, dbo.CONTACTOS.nombres, dbo.CONTACTOS.apellidos,dbo.CONTACTOS.empresa
from dbo.CONTACTOS inner join dbo.EVENTOS on dbo.CONTACTOS.idcontacto = dbo.EVENTOS.idcontacto 
where day(dbo.EVENTOS.fecha)=day(getdate()) and month(fecha)=month(getdate()) and fecha>getdate() order by fecha asc
go
create proc mostrar_evento_finalizado
as
select dbo.EVENTOS.idevento, dbo.EVENTOS.fecha, dbo.EVENTOS.asunto, dbo.CONTACTOS.nombres, dbo.CONTACTOS.apellidos,dbo.CONTACTOS.empresa
from dbo.CONTACTOS inner join dbo.EVENTOS on dbo.CONTACTOS.idcontacto = dbo.EVENTOS.idcontacto 
where fecha<getdate() order by fecha desc
go
create proc mostrar_evento_siguiente_mes
as
select dbo.EVENTOS.idevento, dbo.EVENTOS.fecha, dbo.EVENTOS.asunto, dbo.CONTACTOS.nombres, dbo.CONTACTOS.apellidos,dbo.CONTACTOS.empresa
from dbo.CONTACTOS inner join dbo.EVENTOS on dbo.CONTACTOS.idcontacto = dbo.EVENTOS.idcontacto 
where DATEPART(DAY,fecha)>DATEPART(DAY,getdate()) order by fecha asc
go
create proc insertar_evento
@fecha smalldatetime,
@asunto varchar(255),
@idcontacto int
as
insert into EVENTOS (fecha,asunto,idcontacto)
values  (@fecha,@asunto,@idcontacto)
go
create proc editar_evento
@idevento int,
@fecha smalldatetime,
@asunto varchar(255),
@idcontacto int
as
update EVENTOS set fecha=@fecha,asunto=@asunto,idcontacto=@idcontacto
where idevento=@idevento
go
create proc eliminar_evento
@idcontacto int
as
delete from EVENTOS where idcontacto=@idcontacto
go